local this_thread = love.thread.getThread()
require "love.image"


local w = this_thread:demand("w")
local h = this_thread:demand("h")
local depth = 32
local x0 = -0.65
local y0 = -0.7
local x1 = -0.5
local y1 = -0.6
local dx = x1 - x0
local dy = y1 - y0

local palette = {}
for i=0,depth do
	r = math.floor(i / depth * 1024)
	if r > 255 then
		r = 255
	end
	g = math.floor((i - depth / 3) / depth * 1024)
	if g > 255 then
		g = 255
	end
	if g < 0 then
		g = 0
	end
	b = math.floor((i - depth / 3 * 2) / depth * 1024)
	if b > 255 then
		b = 255
	end
	if b < 0 then
		b = 0
	end
	palette[i] = {R = r, G = g, B = b}
end
palette[depth-1] = {R = 0, G = 0, B = 0}
local image = love.image.newImageData(w, h)
for y=0,h-1 do
	for x=0,w-1 do
		r = 0
		n = 0
		b = x / w * dx + x0
		e = y / h * dy + y0
		i = 0
		while i < depth-1 and r * r < 4 do
			d = r
			r = r * r - n * n + b
			n = 2 * d * n + e
			i = i + 1
		end
		p = palette[i]
		image:setPixel(x, y, p.R, p.G, p.B, 255)
	end
	this_thread:send("progress", math.floor(100/(h-1)*(y+1)))
end
this_thread:send("image", image)