function love.load()
	gen_thread = love.thread.newThread("genimage", "genimage.lua")
	gen_thread:start()
	w = love.graphics.getWidth()
	gen_thread:send("w", w)
	gen_thread:send("h", love.graphics.getHeight())
	imagedata = nil
	font = love.graphics.newFont(72)
	love.graphics.setFont(font)
end

function love.update(dt)
	imagedata = gen_thread:receive("image")
	progress = gen_thread:peek("progress")
	if imagedata then
		image = love.graphics.newImage(imagedata)
	end
end


function love.draw()
	if image then
		love.graphics.draw(image)
	else
		local s = "Loading: " .. progress .. "%"
		local sw = font:getWidth(s)
		love.graphics.print(s, (w / 2) - (sw / 2), 0)
	end
end